import Container from './Container';
import IResolver from '../Contracts/Container/IResolver';
import { Identifier } from '../Support/types';
declare class Resolver implements IResolver {
    protected _container: Container;
    protected _resolved: Map<any, boolean>;
    protected _globalResolvingCallbacks: Function[];
    protected _globalAfterResolvingCallbacks: Function[];
    protected _resolvingCallbacks: Map<any, Function[]>;
    protected _afterResolvingCallbacks: Map<any, Function[]>;
    constructor(container: Container);
    resolve<T>(abstract: Identifier<T>, parameters?: any[] | object): any;
    resolved<T>(abstract: Identifier<T>): boolean;
    forgetResolved<T>(abstract: Identifier<T>): void;
    forgetAllResolved(): void;
    resolving<T>(abstract: Identifier<T> | Function, callback?: Function): void;
    afterResolving<T>(abstract: Identifier<T> | Function, callback?: Function): void;
    protected _getConcrete<T>(abstract: Identifier<T>): Identifier<T> | any;
    protected _isBuildable<U, V>(concrete: Identifier<U> | Function, abstract: Identifier<V>): boolean;
    protected _fireResolvingCallbacks<T>(abstract: Identifier<T>, object: object): void;
    protected _fireAfterResolvingCallbacks<T>(abstract: Identifier<T>, object: object): void;
    protected _fireCallbackArray(object: object, callbacks: Function[]): void;
    protected _getExtenders<T>(abstract: Identifier<T>): Function[];
}
export default Resolver;
